#include        "mem_srv.h"

#asm
    .equ __i2c_port=0x18     ;//PORTB
    .equ __sda_bit=6
    .equ __scl_bit=7
#endasm

#include <i2c.h>
#define EEPROM_BUS_ADDRESS 0xa0


void    MemInit(void)
{
return;
i2c_init();
}

void    MemReadByte(unsigned uAdr,unsigned char *b)
{
unsigned char data;

i2c_start();
i2c_write(EEPROM_BUS_ADDRESS);
i2c_write(uAdr>>8);
i2c_write(uAdr);
i2c_start();
i2c_write(EEPROM_BUS_ADDRESS|1);
data=i2c_read(0);
i2c_stop();
*b=data;
}
 

void    MemWriteByte(unsigned uAdr,unsigned char b)
{
i2c_start();
i2c_write(EEPROM_BUS_ADDRESS);
i2c_write(uAdr>>8);
i2c_write(uAdr);
i2c_write(b);
i2c_stop();
delay_ms(10);
}

           


