#include	"serv.h"
#include	"time1.h"
#include	"ind.h"
#include        "mem_srv.h"
#include        "bud.h"

extern unsigned char   ucPointStart,ucPointStop;
extern eeprom  unsigned char     iePointStart,iePointStop; 
extern eeprom  unsigned char ecPoint[KOL_SAVE2][5];

extern float   fTerm[2];              
extern float   fPress,fVl;
extern unsigned uPress,uVl;
extern int iPress0;    
extern int uKPress;
extern float fKVl,fSVl;
extern unsigned char ukVl;

extern eeprom unsigned char ucSave[MAX_SAVE];
extern unsigned       ucSaveStart,ucSaveStop;
extern eeprom  int     ieSaveStart,ieSaveStop; 

flash unsigned char ucVersion[]=", , ,  2.05";

/* [0] "" */
flash unsigned char sPress[]={224,97,179,187,101,189,184,101,0};
/* [0] "" */
flash unsigned char sVeter[]={66,101,191,101,112,0};
/* [0] "" */
flash unsigned char sVl[]={66,187,97,182,189,111,99,191,196,0};


/* [0] " " */  flash unsigned char smTemp0[]={72,97,32,121,187,184,229,101,0};
/* [1] ""     */  flash unsigned char smTemp1[]={224,111,188,97,0};
flash unsigned char *sTemp[2];
                 

/* [0] "" */  flash unsigned char smDN0[]={168,111,189,101,227,0};
/* [1] "" */  flash unsigned char smDN1[]={66,191,111,112,189,0};
/* [2] "" */  flash unsigned char smDN2[]={67,112,101,227,97,0};
/* [3] ""  */  flash unsigned char smDN3[]={171,101,191,179,0};
/* [4] ""  */  flash unsigned char smDN4[]={168,199,191,189,0};
/* [5] ""  */  flash unsigned char smDN5[]={67,121,178,178,0};
/* [6] "" */  flash unsigned char smDN6[]={66,111,99,186,112,0};

flash unsigned char *sDN[7];


/* [0] ""   */  flash unsigned char smMon0[]={177,189,179,97,112,196,0};
/* [1] ""  */  flash unsigned char smMon1[]={228,101,179,112,97,187,196,0};
/* [2] ""     */  flash unsigned char smMon2[]={77,97,112,191,0};
/* [3] ""   */  flash unsigned char smMon3[]={65,190,112,101,187,196,0};
/* [4] ""      */  flash unsigned char smMon4[]={77,97,185,0};
/* [5] ""     */  flash unsigned char smMon5[]={165,198,189,196,0};
/* [6] ""     */  flash unsigned char smMon6[]={165,198,187,196,0};
/* [7] ""   */  flash unsigned char smMon7[]={65,179,180,121,99,191,0};
/* [8] "" */  flash unsigned char smMon8[]={67,101,189,191,199,178,112,196,0};
/* [9] ""  */  flash unsigned char smMon9[]={79,186,191,199,178,112,196,0};
/* [10] ""   */  flash unsigned char smMon10[]={72,111,199,178,112,196,0};
/* [11] ""  */  flash unsigned char smMon11[]={224,101,186,97,178,112,196,0};

flash unsigned char *sMon[12];


/* [0] " ." */  flash unsigned char sNastr[]={72,97,99,191,112,111,185,186,97,32,190,97,112,97,188,46,0};

/* [0] ""   */  flash unsigned char smParNastr0[]={67,101,186,121,189,227,195,0};
/* [1] ""    */  flash unsigned char smParNastr1[]={77,184,189,121,191,195,0};
/* [2] ""      */  flash unsigned char smParNastr2[]={171,97,99,195,0};
/* [3] ""      */  flash unsigned char smParNastr3[]={224,101,189,196,0};
/* [4] " "  */  flash unsigned char smParNastr4[]={224,101,189,196,32,189,101,227,0};
/* [5] ""     */  flash unsigned char smParNastr5[]={77,101,99,199,229,0};
/* [6] ""       */  flash unsigned char smParNastr6[]={161,111,227,0};
/* [7] "" */  flash unsigned char smParNastr7[]={75,111,112,112,101,186,229,184,199,0};
/* [8] ""     */  flash unsigned char smParNastr8[]={79,178,188,101,189,0};
/* [9] " " */  flash unsigned char smParNastr9[]={168,111,184,99,186,32,227,97,191,192,184,186,111,179,0};
/* [10] "" */  flash unsigned char smParNastr10[]={67,179,199,183,196,0};

/* [0] "" */  flash unsigned char smBud0[]={160,121,227,184,187,196,189,184,186,0};
/* [1] ""   */  flash unsigned char smBud1[]={168,66,67,171,168,67,66,0};
/* [2] ""   */  flash unsigned char smBud2[]={190,179,99,192,190,99,179,0};
                                                                                   

extern int uHis;
extern unsigned char cHis[KOL_SAVE1];

flash unsigned char *sParNastr[11];

extern flash unsigned char ucDayMon[12];
extern unsigned char cFlag;                   // 
                                                //1 -  ;
extern unsigned char *cOut;           
extern unsigned        char    str[2][40];                     // 
extern signed char   ucTime[6];               //ucSec,ucMin,ucHour,ucDay,ucDayN,ucMon;
extern unsigned        uYear;
extern float fVeter;         
extern unsigned uVeter,uKVeter;
extern unsigned char cKeyBuff[16],cKeyStart,cKeyEnd;

signed char    FtoChar(float f)
{
signed char    c,i;

c=f;
i=0;
if(f<0)
        {
        c=-c;
        f=-f;
        i=1;
        }   
f-=c;
if(f>=.5)
        c++;
if(i)
        c=-c;
return c;
}

unsigned char    FtoUChar(float f)
{
unsigned char    c;

c=f;
f-=c;
if(f>=.5)
        c++;
return c;
}

void    TBeep(unsigned uF,unsigned uDl,char kK)
{  
if(!kK)
        return;         
OCR1A=uF;
uDlBeep=uDl;
TCCR1A=0x40;
}

unsigned char GetKey(void)
{                    
unsigned char tmp;

if(cKeyStart==cKeyEnd)
        return 0;
tmp=cKeyBuff[cKeyStart++];
if(cKeyStart>15)
        cKeyStart=0;
return tmp;

}

void    UCToStr(unsigned char *b,unsigned char c)
{
*(b++)='0'+c/10;
*(b++)='0'+c%10;
}           

void    UToStr(unsigned char *b,unsigned u)
{
*(b++)='0'+u/1000;
u%=1000;
*(b++)='0'+u/100;
u%=100;
*(b++)='0'+u/10;
*(b++)='0'+u%10;
}

void    FToStr(unsigned char *b,float f,unsigned char n)
{                     
unsigned tmp,i;

if(f<0)
        {
        *(b++)='-';
        f=0-f;
        }   
else
        *(b++)=' ';
if(f>100)
        {
        *(b++)='E';
        *(b++)='r';
        *(b++)='r';
        return;
        }       
tmp=f/10;
if(tmp)
        *(b++)='0'+tmp;
else
        *(b++)=' ';
f=f-tmp*10;
tmp=f;
*(b++)='0'+tmp;
f=f-tmp;
*(b++)='.';
for(i=0;i<n;i++)
        {
        f*=10;
        tmp=f;
        *(b++)='0'+tmp;
        f=f-tmp;
        }
}

void    FToStr1(unsigned char *b,float f)
{                     
unsigned tmp;

tmp=f/100;
*(b++)='0'+tmp;
f=f-tmp*100;
tmp=f/10;
*(b++)='0'+tmp;
f=f-tmp*10;
tmp=f;
*(b++)='0'+tmp;
f=f-tmp;
*(b++)='.';
        f*=10;
        tmp=f;
        *(b++)='0'+tmp;
        f=f-tmp;
}
                          
void    LoadHis(void)
{
unsigned char j; 
int     u;          
          
u=ucSaveStart+uHis+1;
if(u>=(MAX_SAVE))
        u-=MAX_SAVE;
for(j=0;j<KOL_SAVE1;j++)
        ReadMemoryByte(u,j,cHis+j);
}

void    ShowZap(void)
{
unsigned char   uc=1,tmp;
int             uKolSave;                                                  
                         
uKolSave=ucSaveStop-ucSaveStart;
if(uKolSave<0)
        uKolSave+=MAX_SAVE;
if(!uKolSave)
        return;
uHis=uKolSave-1;         
LoadHis();
cOut[0]=200;                    // -    
cOut[1]=201;                    // 
while(9)
        {
        #asm("WDR"); 
        if(uc)
                {
                uc=0;
                OutInd(1);
                OutInd(0);
                } 
        SaveInf();  
        Idle();
        while(rx_counter)
                {
                tmp=getchar();
                #asm("nop");
                #asm("nop");
                #asm("nop"); 
                SendInf(tmp);
                }
        tmp=GetKey();
        if(!tmp)        
                continue;
        TBeep(64,8,kKey);
        switch(tmp)
                {       
                case    0b1001:         //<-Up             
                cOut[1]--;
                if(cOut[1]<=200)
                        cOut[1]=206;
                uc=1;
                continue;                                 
        
                case    0b1000:         //<-Down
                uHis--;
                if(uHis<0)
                        {
                        uHis=0;
                        TBeep(164,8,kKey);
                        }
                else
                        {
                        LoadHis();
                        uc=1; 
                        }
                continue;                                 
        
                case    0b1010:         //Control
                break;
        
                case    0b0101:         //-> Up    (+1)
                cOut[1]++;
                if(cOut[1]>206)
                        cOut[1]=201;
                uc=1;
                continue;                                 
        
                case    0b0100:         //->Down    (-1)
                uHis++;
                if(uHis>=uKolSave)
                        {
                        uHis--;
                        TBeep(164,8,kKey);
                        }
                else
                        {
                        LoadHis();
                        uc=1;
                        }
                continue;                                 
        
                default:                // 
                continue;
                }
        break;
        }
         
}


void    Control(void)
{
unsigned char   uc=1,tmp;                                                  
unsigned char cOutOld[2];

cOutOld[0]=cOut[0];
cOutOld[1]=cOut[1];

cOut[0]=100;                    // ""
OutInd(0);
cOut[1]=101;                    //
while(9)
        {
        #asm("WDR"); 
        if(uc)
                {
                uc=0;
                OutInd(1);
                } 
        SaveInf();  
        Idle();
        while(rx_counter)
                {
                tmp=getchar();
                #asm("nop");
                #asm("nop");
                #asm("nop"); 
                SendInf(tmp);
                }
        tmp=GetKey();
        if(!tmp)        
                continue;
        TBeep(64,8,kKey);
        switch(tmp)
                {       
                case    0b1000:         //<-Up             
                cOut[1]--;
                if(cOut[1]<=100)
                        cOut[1]=115;
                uc=1;
                continue;                                 
        
                case    0b1001:         //<-Down
                IncDecTime(cOut[1],-1);
                uc=1;
                continue;                                 
        
                case    0b1010:         //Control
                ueKPress=uKPress;
                ShowZap();
                break;
        
                case    0b0100:         //-> Up    (+1)
                cOut[1]++;
                if(cOut[1]>115)
                        cOut[1]=101;
                uc=1;
                continue;                                 
        
                case    0b0101:         //->Down    (-1)
                IncDecTime(cOut[1],1);
                uc=1;
                continue;                                 
        
                default:                // 
                continue;
                }
        break;
        }
         
cOut[0]=cOutOld[0];
cOut[1]=cOutOld[1];
OutInd(0);
OutInd(1);
}

void    IncDecMenu(unsigned char ucStr,signed char u)
{           
if(ucStr>1)
        return;
cOut[ucStr]+=u;
if(cOut[ucStr]<1)
        cOut[ucStr]=7;
if(cOut[ucStr]>7)
        cOut[ucStr]=1;
OutInd(ucStr);
}

void	OutInd(unsigned char cStrNum)
{
unsigned char *b,i=0,j,b1;
unsigned char   tmp;          
static char c=1;         
float   f;
               
if(c)
        {
        c=0;
        sTemp[0]=smTemp0;
        sTemp[1]=smTemp1;
        sDN[0]=smDN0;
        sDN[1]=smDN1;
        sDN[2]=smDN2;
        sDN[3]=smDN3;
        sDN[4]=smDN4;
        sDN[5]=smDN5;
        sDN[6]=smDN6;
        sMon[0]=smMon0;
        sMon[1]=smMon1;
        sMon[2]=smMon2;
        sMon[3]=smMon3;
        sMon[4]=smMon4;
        sMon[5]=smMon5;
        sMon[6]=smMon6;
        sMon[7]=smMon7;
        sMon[8]=smMon8;
        sMon[9]=smMon9;
        sMon[10]=smMon10;
        sMon[11]=smMon11;     
        sParNastr[0]=smParNastr0;
        sParNastr[1]=smParNastr1;
        sParNastr[2]=smParNastr2;
        sParNastr[3]=smParNastr3;
        sParNastr[4]=smParNastr4;
        sParNastr[5]=smParNastr5;
        sParNastr[6]=smParNastr6;
        sParNastr[7]=smParNastr7;
        sParNastr[8]=smParNastr8;
        sParNastr[9]=smParNastr9;
        sParNastr[10]=smParNastr10;
        }
if(!(cFlag&1))
        return;
fPress=(((float)uPress)/1024.+.095)*833.4018697+uKPress;
fVeter=(float)uVeter*uKVeter/10000.;
f=fVl*ukVl;
ukVl++;
f+=(((float)uVl)*.004883-fSVl)/fKVl;
fVl=f/ukVl;
if(ukVl>100)
        ukVl=100;


if(cStrNum>1)
        return;  
b=str[cStrNum];                             
switch(tmp=cOut[cStrNum])
        {
        case    0:                              // 
        break;
        
        case    1:                              //  
        UCToStr(b,ucTime[2]);
        b+=2;
        *(b++)=':';
        UCToStr(b,ucTime[1]);
        b+=2;
        *(b++)=':';
        UCToStr(b,ucTime[0]);
        b+=2;
        *(b++)=' ';
        i=8;          
        for(j=0;i<16;i++,j++)
                {
                b1=sDN[ucTime[4]][j];
                if(!b1)
                        break;
                *(b++)=b1;
                }
        for(;i<16;i++)
                {      
                *(b++)=' ';
                }
        break;
        
        case    2:                              //
        UCToStr(b,ucTime[3]);
        b+=2;
        *(b++)=' ';
        i=2;
        for(j=0;i<16;i++,j++)
                {
                b1=sMon[ucTime[5]][j];
                if(!b1)
                        break;
                *(b++)=b1;
                }            
        *(b++)=' ';
        i++;   
        UToStr(b,uYear);
        b+=4;
        i+=4;
        for(;i<16;i++)
                {      
                *(b++)=' ';
                }
        break;

        case    3:
        case    4:
        case    201:
        case    202:
                                        //3 -   
                                        //4 -  
        CopyStrFlash(cStrNum,sTemp[tmp-(tmp<200?3:201)]);
        b+=10; 
        if(tmp<200)
                FToStr(b,fTerm[tmp-3],1);
        else
                FToStr(b,(signed char)cHis[tmp-197],1);
        b[5]='C';
        break;
                           
        case    5:                      //
        case    110:
        case    203:
        CopyStrFlash(cStrNum,sPress);
        b+=8;                        
        if(tmp<200)
                UToStr(b,fPress);
        else
                UToStr(b,700+cHis[6]);
        *b=' ';
        b[5]='m';
        b[6]='m';
        break;             

        case    6:                      //
        case    111:             
        case    205:
        CopyStrFlash(cStrNum,sVeter);
        b+=6;
        if(tmp<200)
                FToStr1(b,fVeter);
        else
                FToStr(b,cHis[8],1);
        
        b[6]='m';
        b[7]='/';
        b[8]='c';
        break;


        case    112:                    //  - 
        CopyStrFlash(cStrNum,sVl);     //
        b+=9; 
        *(b++)='C';
        b++;
        fSVl=((float)ueSVl)/1000.;
        UToStr(b,ueSVl);
        break;
        
        case    113:                
        CopyStrFlash(cStrNum,sVl);     //-
        fKVl=((float)ueKVl)/10000.;
        b+=9; 
        *(b++)='K';
        *(b++)='.';
        UToStr(b,ueKVl);
        break;

        case    7:                      //
        case    204:
        CopyStrFlash(cStrNum,sVl);
        b+=9;       
        if(tmp<200)
                FToStr(b,fVl,1);
        else
                FToStr(b,cHis[7],1);
        b[5]='%';
        break;             

        case    100:                    // - 
        CopyStrFlash(cStrNum,sNastr);
        break;

        case    101:                    // - 
        case    102:                    // - 
        case    103:                    // - 
        case    104:                    // - 
        CopyStrFlash(cStrNum,sParNastr[tmp-101]);
        b+=12;        
        UCToStr(b,ucTime[tmp-101]);
        break;
        
        case    108:                    // - 
        CopyStrFlash(cStrNum,sParNastr[tmp-101]);
        b+=12;        
        UToStr(b,cSecMax);
        break;

        case    105:                    // -  
        CopyStrFlash(cStrNum,sParNastr[tmp-101]);
        b+=8;        
        for(i=0;sDN[ucTime[4]][i];i++)
                *(b++)=sDN[ucTime[4]][i];
        break;

        case    106:                    // - 
        CopyStrFlash(cStrNum,sParNastr[tmp-101]);
        b+=7;        
        for(i=0;sMon[ucTime[5]][i];i++)
                *(b++)=sMon[ucTime[5]][i];
        break;

        case    107:                    // - 
        CopyStrFlash(cStrNum,sParNastr[tmp-101]);
        UToStr(b+10,uYear);
        break;
        
        case    109:                    // - 
        CopyStrFlash(cStrNum,sParNastr[tmp-101]);
        break;

        case    114:                    // -          
        CopyStrFlash(cStrNum,sParNastr[9]);
        break;                
        
        case    115:                    // -   
        CopyStrFlash(cStrNum,sParNastr[10]);
        b+=7;
        if(cFlag&4)
                {
                *(b++)=224;            //
                *(b++)=97;
                }
        else
                {
                *(b++)=72;              //
                *(b++)=101;
                *(b++)=191;
                }
        break;   
        
        case    200:                    //  
        UCToStr(b,cHis[1]);
        b+=2;
        *(b++)='/';
        UCToStr(b,cHis[2]+1);
        b+=2;
        *(b++)='/';
        UToStr(b,2000+cHis[3]);
        b+=4;
        *(b++)=' ';
        UCToStr(b,cHis[0]);
        b+=2;
        *(b++)=':';
        *(b++)='0';
        *(b++)='0';
        break;
                   
        case    150:                    //
        CopyStrFlash(cStrNum,smBud0);
        b+=10;                     
        *b='1'+uBud;
        break;
        
        case    151:                    // 
        UCToStr(b,cBud[uBud][0]);
        b+=2;
        *(b++)=':';
        UCToStr(b,cBud[uBud][1]);
        b+=2;    
        *(b++)=' ';
        *(b++)=' ';
        b1=cBud[uBud][2];   
        for(i=0,j=1;i<7;i++,j<<=1)
                {          
                if(b1&j)
                        *(b++)=smBud1[i];
                else
                        *(b++)=smBud2[i];
                }
        *(b++)=' ';
        if((b1&j))
                *(b++)='D';
        else
                *(b++)='H';
        
        break;
        
        default:
        return;                   
        }
OutStr(cStrNum);
if(tmp==151)
        {                       
        if(cStrNum)                           // 
                WR4(0,0xC0+CurBud());
        else
                WR4(0,0x80+CurBud());
        WR4(0,0x0d);    //  c 
        }
else
        WR4(0,0x0c);    //                         

}       


void    SaveInf(void)
{           
if(cFlag&0x20)
        return;
if(!(cFlag&0x40))
        return;
if(uYear<2006)                                                 
        {
        cFlag&=~0x40;
        return;
        }                  
ucSaveStop++;
if(ucSaveStop>=(MAX_SAVE))
        ucSaveStop-=MAX_SAVE;
if(ucSaveStop==ucSaveStart)
        {
        ucSaveStart++;
        if(ucSaveStart>=(MAX_SAVE))
                ucSaveStart-=MAX_SAVE;
        }                 
ieSaveStart=ucSaveStart;
ieSaveStop=ucSaveStop;
WriteMemoryByte(0,ucTime[2]);
WriteMemoryByte(1,ucTime[3]);
WriteMemoryByte(2,ucTime[5]);
WriteMemoryByte(3,uYear-2000);
WriteMemoryByte(4,FtoChar(fTerm[0]));
WriteMemoryByte(5,FtoChar(fTerm[1]));
WriteMemoryByte(6,FtoChar(fPress-700));
WriteMemoryByte(7,FtoUChar(fVl));     
WriteMemoryByte(8,FtoUChar(fVeter));     
cFlag&=~0x40;
}                

void    SendInf(unsigned char ucKomm)
{
unsigned char    b,b1;
unsigned char  i,j;
int        k,k1,k2;  
int             i1;
char            tmp[8];

#asm("sei");
while(cFlag&0x10)
        #asm("WDR");
switch(ucKomm)
        {      
       
        case    'S':            //

        k=((int)ucSaveStop)-((int)ucSaveStart);
        if(k<0)
                k+=MAX_SAVE;
        putchar(k&0xFF);
        putchar(k>>8);
        
        for(k=ucSaveStart,k1=ucSaveStop;k!=k1;k++)
                { 
                k2=k+1;
                if(k2>=(MAX_SAVE))
                        k2-=MAX_SAVE;
                if(k>=(MAX_SAVE))
                        k-=MAX_SAVE;
                for(i=0,b1=0;i<KOL_SAVE1;i++)
                        {
                        ReadMemoryByte(k2,i,&b); 
                        putchar(b);
                        b1+=b;
                        }
                putchar(b1);
                
                }
        break;
        
        case    'O':            // 

        k=ucPointStop-ucPointStart;
        if(k<0)
                k+=KOL_SAVE2;
        putchar(k&0xFF);
        putchar(k>>8);
        
        for(k=ucPointStart,k1=ucPointStop;k!=k1;k++)
                { 
                k2=k+1;
                if(k2>=(KOL_SAVE2))
                        k2-=KOL_SAVE2;
                if(k>=(KOL_SAVE2))
                        k-=KOL_SAVE2;
                for(i=0,b1=0;i<5;i++)
                        {
                        b=ecPoint[k2][i];; 
                        putchar(b);
                        b1+=b;
                        }
                putchar(b1);
                
                }
        break;


        case    'C':            //
        ucSaveStart=ucSaveStop;
        ieSaveStart=ucSaveStart;
        break;           
        case    'c':            //
        ucPointStart=ucPointStop;
        iePointStart=ucPointStart;
        break;           
        
        case    'P':            // 
        while(tx_counter)
                #asm("WDR");
        i1=fTerm[0]*10;
        putchar(i1&0xFF);  
        putchar(i1>>8);
        while(tx_counter)
                #asm("WDR");
        i1=fTerm[1]*10;
        putchar(i1&0xFF);  
        putchar(i1>>8);
        while(tx_counter)
                #asm("WDR");
        i1=fPress;
        putchar(i1&0xFF);  
        putchar(i1>>8);
        while(tx_counter)
                #asm("WDR");
        i1=fVl*10;
        putchar(i1&0xFF);  
        putchar(i1>>8);
        while(tx_counter)
                #asm("WDR");
        i1=fVeter*10;
        putchar(i1&0xFF);  
        putchar(i1>>8);
        break;
        
        case    'T':            // 
        for(i=0;i<7;i++)
                {           
                #asm("WDR");
                for(i1=0;i1<20000;i1++)
                        if(rx_counter)
                                break;
                if(!rx_counter)
                        break;
                tmp[i]=getchar();
                }
        if(i!=7)
                break;
        for(i=0;i<6;i++)
                ucTime[i]=tmp[i];
        uYear=2000+tmp[i];
        break;                
        

        case    'V':            //
        while(tx_counter)
                #asm("WDR");
        i=41;                   // 
        putchar(i);
        for(j=0;j<i;j++)
                {
                while(tx_counter)
                        #asm("WDR");
                putchar(ucVersion[j]);  
                }
        break;
        
        }
}

                                            
void  ReadMemoryByte(unsigned uAdr,unsigned char uByte,unsigned char *pucByte)
{     
unsigned        u; 
           
u=(uAdr)*KOL_SAVE1+uByte;
MemReadByte(u,pucByte);
} 


void    WriteMemoryByte(unsigned char uByte,unsigned char ucByte)
{  
unsigned        u;

u=(ucSaveStop)*KOL_SAVE1+uByte;
MemWriteByte(u,ucByte);
}
