#include        "termD.h"
#include        <ds18b20.h>

extern unsigned char ds1820_devices;
extern unsigned char ds1820_rom_codes[2][9];
extern float   fTerm[2];  
extern unsigned char cFlag;            
extern float   fPress;
extern int iPress0;    
extern unsigned uKPress;
extern unsigned uPress,uVl;
char    cIsTemp[2]={0,0};
extern  eeprom  char            ds1820_rom_codes_e[2][9];
extern  eeprom  char            cIsTemp_e[2];
                                                   

void    LoadDS(void)
{
char    i;                    
char *t;
eeprom  char *s;

s=ds1820_rom_codes_e[0];
t=ds1820_rom_codes[0];
for(i=0;i<18;i++,t++,s++)
        *(t)=*(s);
cIsTemp[0]=cIsTemp_e[0];
cIsTemp[1]=cIsTemp_e[1];
}

void    SaveDS(void)
{
char    i;                    
char *t;
eeprom  char *s;

s=ds1820_rom_codes_e[0];
t=ds1820_rom_codes[0];
for(i=0;i<18;i++,t++,s++)
        *(s)=*(t);
cIsTemp_e[0]=cIsTemp[0];
cIsTemp_e[1]=cIsTemp[1];
}

void    CopyDS(char *t,char *s)
{                             
char    i;

for(i=0;i<9;i++,t++,s++)
        *(t)=*(s);
}
                    
void    ObmenDS(void)
{
char    tmp[10],i;

CopyDS(tmp,ds1820_rom_codes[0]);
CopyDS(ds1820_rom_codes[0],ds1820_rom_codes[1]);
CopyDS(ds1820_rom_codes[1],tmp);   
i=cIsTemp[0];
cIsTemp[0]=cIsTemp[1];
cIsTemp[1]=i;
SaveDS();
}

void            FindTemp(void)
{
unsigned char i;


for(i=0;i<5;i++)
       {
       ds1820_devices=w1_search(0xf0,ds1820_rom_codes);
       #asm("WDR");   
       if(ds1820_devices)
               {
               if(ds1820_devices>=2)
                       ds1820_devices=2;
               break;
               }
       }
for(i=0;i<2;i++)
        {
        cIsTemp[i]=0;
        }
for(i=0;i<ds1820_devices;i++)
       {
       ds18b20_init(&ds1820_rom_codes[i][0],20,30,DS18B20_12BIT_RES);
       cIsTemp[i]=1;
       }                                                               
}

void            IzmTemp(void)
{
unsigned char i;    
signed int      iT;  
float           f;

for(i=0;(i<2);i++)
        {     
       if(!cIsTemp[i])        
                {
                fTerm[i]=10000;                                   
                continue;
                }
        w1_init();
        ds18b20_read_spd(ds1820_rom_codes[i]);
        if(w1_dow_crc8(&__ds18b20_scratch_pad,8)==__ds18b20_scratch_pad.crc)
                {
                iT=(((int)__ds18b20_scratch_pad.temp_msb)<<8)| __ds18b20_scratch_pad.temp_lsb;
                f=((float)iT)/16;
                if((f>-50.)&&(f<70))
                        fTerm[i]=f;     
                }
        else
                fTerm[i]=10000;
        }       
w1_init();
w1_write(0xCC);
w1_write(0x44);   
}         

void            IzmPress(void)
{
uPress=read_adc(7);         
}   

void            IzmVl(void)
{
uVl=read_adc(6);         
}   

