#include        "time1.h"
#include        "termD.h"


extern signed char   ucTime[6];                       //ucSec,ucMin,ucHour,ucDay,ucDayN,ucMon;
extern unsigned        uYear;
extern flash unsigned char ucDayMon[12];
extern  unsigned char cSecMax;
extern int uKPress;

char    IsVis(void)
{
    if (!(uYear%100))
        return (uYear%400)?0:1;
    else
        return (uYear%4)?0:1;
}

char    NewMon(void)
{        
char tmp;

if(ucTime[5]!=1)
        {                       // 
        if(ucTime[3]>ucDayMon[ucTime[5]])
                return 1;
        else
                return 0;
        }                
else
        {
        tmp=28;
        if(IsVis())
                tmp++;
        if(ucTime[3]>=tmp)
                return 1;
        else
                return 0;
        }
}
      
void    IncDecTime(unsigned char ucKto,signed char PM)
{     
ucKto-=101;         
switch(ucKto)
        {
        case    6:            //
        uYear+=PM;
        return;

        case    7:            //
        cSecMax+=PM;
        ucfSecMax=cSecMax;
        return;

        case    9:            //
        uKPress+=PM;
        ueKPress=uKPress;
        return;


        case    10:            //
        uKVeter+=PM;
        return;


        case    11:            //
        ueSVl+=PM;
        return;
        case    12:            //
        ueKVl+=PM;
        return;

        case    0:          //sec
        case    1:          //min
        ucTime[ucKto]+=PM;
        if(ucTime[ucKto]>=60)
                ucTime[ucKto]=0;
        if(ucTime[ucKto]<0)
                ucTime[ucKto]=59;
        return;
        
        case    2:            //
        ucTime[ucKto]+=PM;
        if(ucTime[ucKto]>=24)
                ucTime[ucKto]=0;
        if(ucTime[ucKto]<0)
                ucTime[ucKto]=23;
        return;

        case    3:            //
        ucTime[ucKto]+=PM;
        if(ucTime[ucKto]>ucDayMon[ucTime[106-101]])
                ucTime[ucKto]=1;
        if(ucTime[ucKto]<1)
                ucTime[ucKto]=ucDayMon[ucTime[106-101]];
        
        return;

        case    4:            // 
        ucTime[ucKto]+=PM;
        if(ucTime[ucKto]>=7)
                ucTime[ucKto]=0;
        if(ucTime[ucKto]<0)
                ucTime[ucKto]=6;
        return;

        case    5:            // 
        ucTime[ucKto]+=PM;
        if(ucTime[ucKto]>=12)
                ucTime[ucKto]=0;
        if(ucTime[ucKto]<0)
                ucTime[ucKto]=11;
        return;   
        
        case    8:              // 
        ObmenDS();
        return;

        case    13:              // 
        FindTemp();
        SaveDS();
        return;

        case    14:              ///   
        cFlag^=4;
        return;
        }
}

void   FirstTime(void)
{                            
ucTime[0]=0;
ucTime[1]=0;
ucTime[2]=0;
ucTime[3]=1;
ucTime[4]=0;
ucTime[5]=0;
uYear=2005;
}


void   IncSec(void)
{     
ucTime[0]++;


if(ucTime[0]>=60)
        {
        ucTime[1]++;
        ucTime[0]=0;
        TstBud();

        if(ucTime[1]>=60)
                {
                ucTime[2]++;
                ucTime[1]=0;                  
                cFlag|=0x40;

                if(ucTime[2]>=24)
                        {
                        ucTime[2]=0;
                        ucTime[3]++;
                        ucTime[4]++;
                        if(ucTime[4]>=7)
                                ucTime[4]=0;
                        if(NewMon())
                                {
                                ucTime[3]=1;
                                ucTime[5]++;
                                if(ucTime[5]>=12)
                                        {
                                        ucTime[5]=0;
                                        uYear++;
                                        }
                                }
                        }
                }
        }   
 }         
 
 
 long    DT(signed char d1,signed char m1,int y1)
 {
 long   l=0;                                    
 int    i=2001;  
 signed char m=0;
               
 while(i<y1)
        {
        l+=365;
        if(!(i%4))
                l++;
        i++;
        }       
 while(m<m1)
        {
        l+=ucDayMon[m];
        if((!(i%4))&&(m==1))
                l--;
        m++;
        }          
 l+=d1;
 return l;
 }     
 
signed char FL(signed char d1,signed char m1,int y1)
{
long    j;
float   dd,d;
signed char i;

j=DT(d1,m1,y1); 

dd=0.20439731+j*0.03386319269+j*j*0.0301e-14;
d=dd-((long)dd);
if(d>0.5)
        d=1-d,i=-20;
else
        i=20;
return d*i;
}
