#include	"bud.h"
#include	"serv.h"

extern  unsigned char uBud,ucCurBud;
extern eeprom  unsigned char ucBud[KOL_BUD1][3];       //0 - 
                                                //1 - 
                                                //2 -   ()
extern unsigned char cBud[KOL_BUD1][3];
       
extern unsigned char   ucPointStart,ucPointStop;
extern eeprom  unsigned char     iePointStart,iePointStop; 
extern eeprom  unsigned char ecPoint[KOL_SAVE2][5];

void    LoadBud(void)
{
char    i;

for(i=0;i<KOL_BUD1;i++)
        {
        cBud[i][0]=ucBud[i][0];
        cBud[i][1]=ucBud[i][1];
        cBud[i][2]=ucBud[i][2];
        }
}

void    SaveBud(unsigned char n)
{
ucBud[n][0]=cBud[n][0];
ucBud[n][1]=cBud[n][1];
ucBud[n][2]=cBud[n][2];
}

unsigned char CurBud(void)
{
static  unsigned char c[]={1,4,7,8,9,10,11,12,13,15};                    //    

return c[ucCurBud];
}

void    ControlBud(void)
{
unsigned char   uc=1,tmp;                                                  
unsigned char cOutOld[2];

cOutOld[0]=cOut[0];
cOutOld[1]=cOut[1];

cOut[0]=150;                    // ""
OutInd(0);
cOut[1]=151;                    
while(9)
        {
        #asm("WDR"); 
        if(uc)
                {
                uc=0;
                OutInd(1);
                } 
        SaveInf();  
        Idle();
        while(rx_counter)
                {
                tmp=getchar();
                #asm("nop");
                #asm("nop");
                #asm("nop"); 
                SendInf(tmp);
                }
        tmp=GetKey();
        if(!tmp)        
                continue;
        TBeep(64,8,kKey);
        switch(tmp)
                {       
                case    0b1000:         //<-Up               
                SaveBud(uBud);
                uBud++;
                if(uBud>=KOL_BUD1)
                        uBud=0;
                ucCurBud=0;
                uc=1;      
                OutInd(0);
                continue;                                 
        
                case    0b1001:         //<-Down
                if(ucCurBud)
                        ucCurBud--;
                else
                        ucCurBud=9;
                uc=1;
                continue;                                 
        
                case    0x0F:         //
                SaveBud(uBud);
                break;
        
                case    0b0100:         //-> Up     
                if(ucCurBud==0)
                        {
                        cBud[uBud][0]++;
                        if(cBud[uBud][0]>23)
                                cBud[uBud][0]=0;
                        }
                else if(ucCurBud==1)
                        {
                        cBud[uBud][1]++;
                        if(cBud[uBud][1]>59)
                                cBud[uBud][1]=0;
                        }              
                else
                        {
                        tmp=1<<ucCurBud-2; 
                        cBud[uBud][2]^=tmp;
                        }
                uc=1;
                continue;                                 
        
                case    0b0101:         //->Down    (-1)
                ucCurBud++;
                if(ucCurBud>9)
                        ucCurBud=0;
                uc=1;
                continue;                                 
        
                default:                // 
                continue;
                }
        break;
        }
         
cOut[0]=cOutOld[0];
cOut[1]=cOutOld[1];
OutInd(0);
OutInd(1);
}                         

void    TstBud(void)
{
char    i;
unsigned char c;

for(i=0;i<KOL_BUD1;i++)
        {    
        c=cBud[i][0];
        c=cBud[i][1];
        c=cBud[i][2];
        if(!(c&0x80))
                continue;
        c=cBud[i][0];
        if(c!=ucTime[2])
                continue;
        if(cBud[i][1]!=ucTime[1])
                continue;   
        if(!(cBud[i][2]&(1<<ucTime[4])))
                continue;
        OCR1A=100;
        TCCR1A=0x40;
        cFlag|=2;
        }
}            

void    AddPoint(void)
{
if(uYear<2006)                                               
        {
        cFlag&=~0x40;
        return;
        }                  
ucPointStop++;
if(ucPointStop>=(KOL_SAVE2))
        ucPointStop-=KOL_SAVE2;
if(ucPointStop==ucPointStart)
        {
        ucPointStart++;
        if(ucPointStart>=(KOL_SAVE2))
                ucPointStart-=KOL_SAVE2;
        }                 
iePointStart=ucPointStart;
iePointStop=ucPointStop;
ecPoint[ucPointStop][0]=ucTime[1];
ecPoint[ucPointStop][1]=ucTime[2];
ecPoint[ucPointStop][2]=ucTime[3];
ecPoint[ucPointStop][3]=ucTime[5];
ecPoint[ucPointStop][4]=uYear-2000;

}