#include        "ind.h"
#include        <delay.h>

extern unsigned        char    str[2][40];                     // 


/* [0] "  " */
flash char Init0[]={32,32,77,101,191,101,111,99,191,97,189,229,184,199,0};

/* [0] "   " */
flash char Init1[]={32,32,32,32,32,32,171,97,99,195,0};

/* [0] "" */
flash char Init2[]={32,32,80,97,183,112,97,178,111,191,97,187,0};

/* [0] "." */
flash char Init3[]={32,32,65,46,164,121,185,186,111,179,0};

/* [0] "." */  
flash unsigned char Init4[]={32,32,165,46,75,179,97,99,111,179,0};

  
unsigned char RDCom8(void)
{      
unsigned char tmp;

#asm
sbi     0x15,4              // PORTC,5 (RW) - !
cbi     0x15,3              // PORTC,6 (RS) - !
nop
nop
nop  
nop
nop
nop  
sbi     0x15,5          //PORTC,5(E)
nop
nop
nop  
nop
nop
nop
#endasm
tmp=PINA&0x0f;
#asm
nop
nop
nop  
nop
nop
nop  
cbi     0x15,5          //PORTC,5(E)
cbi     0x15,4              // PORTC,5 (RW) - !
#endasm
return tmp;
}


void    WRCom8(unsigned char c)
{                            
#asm
cbi     0x15,4              // PORTC,5 (RW) - !
cbi     0x15,3              // PORTC,6 (RS) - !
nop
nop
nop  
nop
nop
nop  
#endasm
DDRA=0x0f;                  //   
c>>=4;
PORTA=c;   
#asm
sbi     0x15,5          //PORTC,5(E)
nop
nop
nop
nop
nop  
nop
cbi     0x15,5
#endasm
DDRA=0x0;                  //8    
PORTA=0;
}

unsigned char RDCom4(void)
{
unsigned char tmp,tmp1;

#asm
sbi     0x15,4              // PORTC,5 (RW) - !
cbi     0x15,3              // PORTC,6 (RS) - !
nop
nop
nop
nop  
nop
nop  
sbi     0x15,5          //PORTC,5(E)
nop
nop
nop
nop  
nop
nop
#endasm
tmp=PINA&0x0f;
tmp=PINA&0x0f;
#asm
cbi     0x15,5          //PORTC,5(E)  
nop
nop
nop
nop  
nop
nop  
sbi     0x15,5          //PORTC,5(E)
nop
nop
nop
nop
nop  
nop  
#endasm
tmp1=PINA&0x0f;
tmp1=PINA&0x0f;
#asm
cbi     0x15,5          //PORTC,5(E)  
cbi     0x15,4              // PORTC,5 (RW) - !
#endasm
return (tmp<<4)|tmp1;
}

void    WhiteBisiy(void)
{
while(1)
        {
        if(!(RDCom4()&0x80))
                break;
        #asm("wdr");
        }
}

void    WR4(unsigned char cKom,unsigned char c)
{                                           

WhiteBisiy();
if(cKom)                                ///
        {
        #asm("sbi     0x15,3");                                             
        }

else    
        {
        #asm("cbi     0x15,3");    
        }
DDRA=0x0f;                  //  
PORTA=(c>>4);
#asm
sbi     0x15,5          //PORTC,5(E)
nop
nop
nop
nop
nop  
nop  
nop
nop
nop  
cbi     0x15,5          //PORTC,5(E)
nop
nop
nop
nop
nop  
nop  
nop
nop
nop  
#endasm
PORTA=(c&0x0f);
#asm
sbi     0x15,5          //PORTC,5(E)
nop
nop
nop
nop
nop  
nop  
cbi     0x15,5          //PORTC,5(E)
#endasm
                                         
DDRA=0x0;                  //8    
PORTA=0x0;
}

void    CopyStrFlash(unsigned char n,flash unsigned char *s)
{
unsigned char   *b;
unsigned char   i,j;

if(n)
        n=1;
b=str[n];
for(i=j=0;i<16;i++)
        {       
        if(s[j])
                *b=s[j],j++;
        else
                *b=' ';
        b++;
        }
}

void    OutStr(unsigned char n)
{                                                  
unsigned char   *b,i;

if(n)                           // 
        WR4(0,0xC0),n=1;
else
        WR4(0,0x80);
b=str[n];
i=0;
while(*b)
        {         
                WR4(1,*b);
                b++;
        }
}


void    InitInd(void)
{            
#asm("wdr");
delay_ms(20);
#asm("wdr");
WRCom8(0x30);
delay_us(4100);
#asm("wdr");
WRCom8(0x30);
delay_us(100);
WRCom8(0x30); 
#asm("wdr");
while(1)
        {
        if(!(RDCom8()&0x8))
                break;
        #asm("wdr");
        }   
WRCom8(0x20);   // 4-  ;
WR4(0,0x28);    //2 , 4 
WR4(0,0x0c);    //                         
WR4(0,0x06);    //   
CopyStrFlash(0,Init0);
CopyStrFlash(1,Init1); 

OutStr(0);
OutStr(1);
delay_ms(2000);            
#asm("wdr");
CopyStrFlash(0,Init2);
OutStr(0);
CopyStrFlash(1,Init4);
OutStr(1);
delay_ms(2000);         
#asm("wdr");
CopyStrFlash(1,Init3);
OutStr(1);
delay_ms(2000);         
#asm("wdr");

}

